//<script>
var WEBUI_VALIDATION_VER = "1627";
var Page_IsValid = true; // Aggregated validation state for all the validators on the page
var Page_FieldsToValidate = new Array; // All the controls being validated
var Page_PostIfValidationError = false;
var Page_ValidationActive = false;

function ValidatorHide(Validator) {
    Validator.IsValid = true;
    if (typeof(Validator.Display) == "string") {
        if (Validator.Display == "None") {
            return;
        }
        if (Validator.Display == "Dynamic") {
            Validator.style.display="none";
            return;
        }        
    }
    Validator.style.visibility="hidden";
}

function ValidatorShow(Validator) {
    Validator.IsValid = false;
    if (typeof(Validator.Display) == "string") {    
        if (Validator.Display == "None") {
            return;
        }
        if (Validator.Display == "Dynamic") {
            Validator.style.display="inline";
            return;
        }
    }
    Validator.style.visibility="visible";
}

function ValidatorUpdateIsValid() {
    for (i=0; i < Page_Validators.length; i++) {
        if (!Page_Validators[i].IsValid) {
            Page_IsValid = false;
            return;
        }
   }
   Page_IsValid = true;
}

function ValidatorHookupChangeEvent(Control, Validator, EventName) {
    if (typeof(Control.tagName) == "undefined" && typeof(Control.length) == "number") {
        // Radio Button groups need to be recursed into
        for (j=0; j < Control.length; j++) {
            ValidatorHookupChangeEvent(Control[j], Validator, EventName);            
        }
        return;                
    } else {
        if (typeof(Control.ValidatorOnChangeHandler) != "string") {
            Control.ValidatorOnChangeHandler = "";
            Page_FieldsToValidate[Page_FieldsToValidate.length] = Control;
        }
    }
    Control.ValidatorOnChangeHandler += EventName + "(" + Validator.id + "); ";
}

function ValidatorHookup(ValidatorArray, EventName) {
    for (i=0; i < ValidatorArray.length; i++) {
        validator = ValidatorArray[i];    
        control = document.all[validator.ControlToValidate];
        if (typeof(control) != "undefined") {
            ValidatorHookupChangeEvent(control, validator, EventName);
        }
        if (typeof(validator.IsValid) == "string") {
            if (validator.IsValid == "False") {
                validator.IsValid = false;                                
                Page_IsValid = false;
            } else {
                validator.IsValid = true;
            }
        } else {
            validator.IsValid = true;
        }
    }
    
}

function ValidatorGetValue(id) {
    control = document.all[id];
    if (typeof(control.value) == "string") {
        return control.value;
    }
    if (typeof(control.tagName) == "undefined" && typeof(control.length) == "number") {
        for (j=0; j < control.length; j++) {
            if (control[j].type == "radio") {
                if (control[j].status == true) {
                    return control[j].value;
                }
            }
        }
    }
    return "";
}

function ValidatorCommon_onload() {
    for (i=0; i < Page_FieldsToValidate.length; i++) {
        control = Page_FieldsToValidate[i];
        var existingEvent;
        if (control.type == "radio") {
            existingEvent = control.onclick;
        } else {
            existingEvent = control.onchange;
        }
        if (typeof(existingEvent) == "function" ) {            
            var s = "" + existingEvent;
            s = s.substring(s.indexOf("{") + 1, s.indexOf("}"));
            control.ValidatorOnChangeHandler += s;
        }
        eval("function " + control.id + "_onchange () {" + control.ValidatorOnChangeHandler + "}");
        if (control.type == "radio") {
            eval("control.onclick = " + control.id + "_onchange;");
        } else {            
            eval("control.onchange = " + control.id + "_onchange;");
        }
    }
}

function ValidatorCommon_onsubmit() {
    RequiredFieldValidator_onsubmit();
    if (!Page_PostIfValidationError) {
        event.returnValue = Page_IsValid;
    }
    ValidationSummary_onsubmit();
}


function CompareValidator_onload() {
    if (typeof(Page_CompareValidators) == "undefined") return;        

    ValidatorHookup(Page_CompareValidators, "CompareValidator_onchange");
	
    // Add onchange handlers for all ControlToCompare
    for (i=0; i < Page_CompareValidators.length; i++) {
        validator = Page_CompareValidators[i];
        if (typeof(validator.ControlToCompare) == "string") {
            control = document.all[validator.ControlToCompare];
            ValidatorHookupChangeEvent(control, validator, "CompareValidator_onchange");
        }
    }
}

function CompareValidator_onchange(Validator) {
    if (document.all[Validator.ControlToValidate].value != "") {
        if (null == document.all[Validator.ControlToCompare]) {
            if (typeof(Validator.ValueToCompare) == "string") {
                compareTo = Validator.ValueToCompare;
            } else {
                compareTo = "";
            }
        } else {
            compareTo = document.all[Validator.ControlToCompare].value;
        }
        if (!ValidatorCompare(document.all[Validator.ControlToValidate].value,compareTo,Validator.Operator,Validator.Type)) {
            ValidatorShow(Validator);
        } else {
            ValidatorHide(Validator);
        }
    } else {
        ValidatorHide(Validator);
    }
    ValidatorUpdateIsValid();
}

function CustomValidator_onload() {
    if (typeof(Page_CustomValidators) == "undefined") return;
    ValidatorHookup(Page_CustomValidators, "CustomValidator_onchange");
}

function CustomValidator_onchange(Validator) {
    valid = true;
    if (event.srcElement.value != "") {
        if (typeof(Validator.ClientValidationFunction) == "string") {
            eval("valid = " + Validator.ClientValidationFunction + "(Validator, event.srcElement.value);");
        }        
    }
    if (valid) {
        ValidatorHide(Validator);
    } else {
        ValidatorShow(Validator);
    }
    ValidatorUpdateIsValid();
}

function RegularExpressionValidator_onload() {
    if (typeof(Page_RegularExpressionValidators) == "undefined") return;
    ValidatorHookup(Page_RegularExpressionValidators, "RegularExpressionValidator_onchange");
}

function IsMatch(pattrn, strng) {
    var rx = new RegExp(pattrn);
    var match = rx.exec(strng);
    if (match == null) {
        return false;
    }
    return (match.index == 0 && match.lastIndex == strng.length);
}


function RegularExpressionValidator_onchange(Validator) {
    if (event.srcElement.value != "") {
        if (!IsMatch(Validator.ValidationExpression, event.srcElement.value)) {
            ValidatorShow(Validator);
        } else {
            ValidatorHide(Validator);
        }
    } else {
        ValidatorHide(Validator);
    }
    ValidatorUpdateIsValid();
}

function RequiredFieldValidator_onload() {
    if (typeof(Page_RequiredFieldValidators) == "undefined") return;
    for (i=0; i < Page_RequiredFieldValidators.length; i++) {
        rfv = Page_RequiredFieldValidators[i];
        if (typeof(rfv.InitialValue) != "string") {
            rfv.InitialValue = "";
        }
    }
    ValidatorHookup(Page_RequiredFieldValidators, "RequiredFieldValidator_onchange");
}

function RequiredFieldValidator_onsubmit() {
    if (typeof(Page_RequiredFieldValidators) == "undefined") return;
    var Validator; 
    for (i=0; i < Page_RequiredFieldValidators.length; i++) {
        Validator= Page_RequiredFieldValidators[i];
		
        Validator.IsValid = !(ValidatorGetValue(Validator.ControlToValidate) == Validator.InitialValue);
        if (Validator.IsValid) {
            ValidatorHide(Validator);
        } else {
            ValidatorShow(Validator);
        }
    }
    ValidatorUpdateIsValid();
}

function RequiredFieldValidator_onchange(Validator) {
    if (ValidatorGetValue(Validator.ControlToValidate) == Validator.InitialValue) {
        ValidatorShow(Validator);
    } else {
        ValidatorHide(Validator);
    }
    ValidatorUpdateIsValid();
}


function RangeValidator_onload() {
    if (typeof(Page_RangeValidators) == "undefined") return;
    ValidatorHookup(Page_RangeValidators, "RangeValidator_onchange");
	
    // Add onchange handlers for all MinimumControls and MaximumControls
    for (i=0; i < Page_RangeValidators.length; i++) {
        validator = Page_RangeValidators[i];
        if (typeof(validator.MinimumControl) == "string") {
            control = document.all[validator.MinimumControl];
            ValidatorHookupChangeEvent(control, validator, "RangeValidator_onchange");
        }
        if (typeof(validator.MaximumControl) == "string") {
            control = document.all[validator.MaximumControl];
            ValidatorHookupChangeEvent(control, validator, "RangeValidator_onchange");
        }
    }
}

function RangeValidator_onchange(Validator) {
    if (document.all[Validator.ControlToValidate].value != "") {
        if (null == document.all[Validator.MinimumControl]) {
            if (typeof(Validator.MinimumValue) == "string") {
                minimum = Validator.MinimumValue;
            } else {
                minimum = "";
            }
        } else {
            minimum = document.all[Validator.MinimumControl].value;
        }
        if (null == document.all[Validator.MaximumControl]) {
            if (typeof(Validator.MaximumValue) == "string") {
                maximum = Validator.MaximumValue;
            } else {
                maximum = "";
            }
        } else {
            maximum = document.all[Validator.MaximumControl].value;
        }
        
        if (ValidatorCompare(document.all[Validator.ControlToValidate].value,minimum,"GreaterThanEqual",Validator.Type) &&
            ValidatorCompare(document.all[Validator.ControlToValidate].value,maximum,"LessThanEqual",Validator.Type)) {
            ValidatorHide(Validator);
        } else {
            ValidatorShow(Validator);
        }
    } else {
        ValidatorHide(Validator);
    }
    ValidatorUpdateIsValid();
}

function ValidationSummary_onsubmit() {
    if (typeof(Page_ValidationSummaries) == "undefined") return;
    var summary;
    var sums;
    for (sums=0; sums < Page_ValidationSummaries.length; sums++) {
        summary = Page_ValidationSummaries[sums];
        if (!Page_IsValid) {
            if (summary.ShowSummary != "False") {
                if (typeof(summary.DisplayMode) != "string") {
                    summary.DisplayMode = "BulletList";
                }
                switch (summary.DisplayMode) {
                    case "List":
                        headerSep = "<br>";
                        first = "";
                        pre = "";
                        post = "<br>";
                        final = "";
                        break;
                        
                    case "BulletList":
                    default: 
                        headerSep = "";
                        first = "<ul>";
                        pre = "<li>";
                        post = "</li>";
                        final = "</ul>";
                        break;
                        
                    case "SingleParagraph":
                        headerSep = " ";
                        first = "";
                        pre = "";
                        post = " ";
                        final = "<br>";
                        break;
                }
                var s = "";
                if (typeof(summary.HeaderText) == "string") {
                    s += summary.HeaderText + headerSep;
                }
                s += first;
                for (i=0; i<Page_Validators.length; i++) {
                    if (!Page_Validators[i].IsValid && typeof(Page_Validators[i].ErrorMessage) == "string") {
                        s += pre + Page_Validators[i].ErrorMessage + post;
                    }
                }   
                s += final;
                summary.innerHTML = s; 
                window.scrollTo(0,0);
            }
			if (summary.ShowMessageBox == "True") {
                s = "";
                if (typeof(summary.HeaderText) == "string") {
                    s += summary.HeaderText + "<BR>";
                }
                for (i=0; i<Page_Validators.length; i++) {
                    if (!Page_Validators[i].IsValid && typeof(Page_Validators[i].ErrorMessage) == "string") {
                        switch (summary.DisplayMode) {
                            case "List":
                                s += Page_Validators[i].ErrorMessage + "<BR>";
                                break;
                                
                            case "BulletList":
                            default: 
                                s += "  - " + Page_Validators[i].ErrorMessage + "<BR>";
                                break;
                                
                            case "SingleParagraph":
                                s += Page_Validators[i].ErrorMessage + " ";
                                break;
                        }
                    }
                }
                span = document.createElement("SPAN");
                span.innerHTML = s;
                s = span.innerText;
                alert(s);
            }
        }
    }
}


function ValidatorOnLoad() {
    CompareValidator_onload();
    CustomValidator_onload();
    RangeValidator_onload();
    RegularExpressionValidator_onload();
    RequiredFieldValidator_onload();
    ValidatorCommon_onload();
    Page_ValidationActive = true;
}